--=========================================================
-- Project 	: Hardware Implementation of NTRU Cryptosystems
-- Author	: Malik Umar Sharif, Kevin Briggs
--=========================================================

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity fixed_rotator is
generic
(
    WIDTH : integer;
    ROT   : integer
);
port
(
	a : in std_logic_vector(WIDTH-1 downto 0);
	y : out std_logic_vector(WIDTH-1 downto 0)
) ;
end fixed_rotator;

architecture left of fixed_rotator is
begin
	y <= a(WIDTH-1-ROT downto 0) & a(WIDTH-1 downto WIDTH-ROT);
end left;

architecture right of fixed_rotator is
begin
	y <= a(ROT-1 downto 0) & a(WIDTH-1 downto ROT);
end right;
-- ========================================================

