-- =====================================================================
-- Copyright  2018 by Cryptographic Engineering Research Group (CERG)
-- ECE Department, George Mason University
-- Fairfax, VA, U.S.A.
-- Author: Kevin Briggs
-- =====================================================================
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

library work;
use work.ntru_pkg.all;

-- Input Data Conversion Unit for decryption
entity idcu_d is	
generic 
(
	iw : integer := 32;
	ow : integer := 11
);
port
(
    sdi_data : in std_logic_vector(iw-1 downto 0);
    F_ram    : out std_logic_vector(ow-1 downto 0)
); 
end idcu_d;   

-- ==========================================================================
architecture arch of idcu_d is
begin
    F_ram <= sdi_data(ow-1 downto 0);
end arch;
-- ==========================================================================