-- =========================================================================
-- Copyright © 2017-2018 by Cryptographic Engineering Research Group (CERG),
-- ECE Department, George Mason University
-- Fairfax, VA, U.S.A.
-- Author: Farnoud Farahmand
-- =========================================================================

library ieee;
use ieee.std_logic_1164.all;

-- mod4 operation
entity mod4 is
generic
(
    w : integer := 32;
    ALPHA : integer := 11
);
port
(
	din		: in std_logic_vector(ALPHA*2*w-1 downto 0);
	dout    : out std_logic_vector(2*2*w-1 downto 0)
);
end mod4;

architecture arch of mod4 is
begin

gen_mod: for i in 0 to 63 generate

    dout((i*2)+2-1 downto i*2) <= din((i*11)+2-1 downto i*11) ;

end generate;

end arch;
